plugins {
    id("jfmod") version "1.6-SNAPSHOT"
}

allprojects { group = "io.gitlab.jfronny" }
base.archivesName = "modsmod"

val commonsVersion = "1.7-SNAPSHOT"
jfMod {
    minecraftVersion = "1.20.5"
    yarn("build.1")
    loaderVersion = "0.15.10"
    libJfVersion = "3.15.5"
    fabricApiVersion = "0.97.6+1.20.5"

    modrinth {
        projectId = "modsmod"
        requiredDependencies.add("libjf")
        optionalDependencies.add("modmenu")
    }
    curseforge {
        projectId = "405095"
        requiredDependencies.add("libjf")
        optionalDependencies.add("modmenu")
    }
}

dependencies {
    modImplementation("io.gitlab.jfronny.libjf:libjf-config-core-v2")
    modImplementation("io.gitlab.jfronny.libjf:libjf-unsafe-v0")

    compileOnly("io.gitlab.jfronny:commons-serialize-generator-annotations:$commonsVersion")
    annotationProcessor("io.gitlab.jfronny:commons-serialize-generator:$commonsVersion")

    // Dev env
    modLocalRuntime("io.gitlab.jfronny.libjf:libjf-config-ui-tiny")
    modLocalRuntime("io.gitlab.jfronny.libjf:libjf-devutil")
    modLocalRuntime("com.terraformersmc:modmenu:10.0.0-beta.1")
    // for modmenu
    modLocalRuntime("net.fabricmc.fabric-api:fabric-resource-loader-v0")
    modLocalRuntime("net.fabricmc.fabric-api:fabric-screen-api-v1")
    modLocalRuntime("net.fabricmc.fabric-api:fabric-key-binding-api-v1")
}
